<?php
include 'bwmon-quimbey-auth.php';

if (sizeof($argv) > 1) {
    $select_time = $argv[1];
}
else {
    $select_time = 60;
}

function getUrl($url, $method='', $vars='') 
{
    $ch = curl_init();
    if ($method == 'post') 
    {
        curl_setopt ($ch, CURLOPT_POST, 1);
        curl_setopt ($ch, CURLOPT_POSTFIELDS, $vars);
    }

    curl_setopt ($ch, CURLOPT_URL, $url);
    curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt ($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; rv:1.7.12) Gecko/20050915 Firefox/1.0.7");
    curl_setopt ($ch, CURLOPT_HEADER, 1);
    curl_setopt ($ch, CURLOPT_MAXREDIRS, 10);
    curl_setopt ($ch, CURLOPT_TIMEOUT, 0);
    curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, 0);
    curl_setopt ($ch, CURLOPT_FAILONERROR, true);
    curl_setopt ($ch, CURLOPT_FOLLOWLOCATION, true);
    curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, false);
    $buffer = curl_exec($ch);
    curl_close ($ch);

    return $buffer;
}

// Get cookie (log in)
$loginFields = array('username' => $router_user, 'password' => $router_pw);
$got = getUrl("http://192.168.1.254/cgi-bin/luci?status=1", 'post', $loginFields);
preg_match_all('/^Set-Cookie:\s*([^\r\n]*)/mi', $got, $cookieline);
$cookies = array();
foreach ($cookieline[1] as $m) {
    list($name, $value) = explode('=', $m, 2);
    $cookies[$name] = $value;
}
list($sysauth, $path) = explode(';', $cookies['sysauth'], 2);
list($dummy, $path) = explode('=', $path, 2);

// Get data
$opts = array(
    'http'=>array(
        'method' => "GET",
        'header' => "Accept-language: en\r\n" .
                    "Cookie: sysauth=$sysauth\r\n" .
                    "Content-Type: application/x-www-form-urlencode"
     )
);
$context = stream_context_create($opts);
$dummy = file_get_contents("http://192.168.1.254$path/admin/status/", false, $context);
$dummy = file_get_contents("http://192.168.1.254$path/admin/status/realtime/", false, $context);
$dummy = file_get_contents("http://192.168.1.254$path/admin/status/realtime/bandwidth/", false, $context);
$dummy = file_get_contents("http://192.168.1.254$path/admin/status/realtime/bandwidth/pppoe-wan", false, $context);
$raw_data = file_get_contents("http://192.168.1.254$path/admin/status/realtime/bandwidth_status/pppoe-wan", false, $context);

$data = json_decode($raw_data);

$i = 0;
$speeds = Array();
$last_time = $data[sizeof($data)-1][0];

for ($i = 1; $i < sizeof($data); $i++) {
    $time_delta = $data[$i][0] - $data[$i - 1][0];
    $data_delta = $data[$i][1] - $data[$i - 1][1];
    $speed = $data_delta / $time_delta;
    $temp_mbps = $speed / 1024 / 1024;
    
    $time_age = $last_time - $data[$i][0];
    if (($time_age + $time_delta) < $select_time) {
        $speeds[$i - 1] = $speed;
        //echo "  $time_delta\t  $temp_mbps\r\n";
    }
    else {
        $speeds[$i - 1] = 0;
        //echo "--$time_delta\t  $temp_mbps\r\n";
    }
}

$max = max($speeds);
$max_mbps = $max / 1024 / 1024;
echo $max_mbps;
